{Effet raster : par Plouf : theplouf@yahoo.com}

program test;
var y,c,c0:integer;
    pal:array[0..383,0..2] of byte;

{Modifie les registres d'une entre dans la palette des couleurs}
procedure setcolor(n,r,v,b:byte); assembler;
asm
  mov dx, 3c8h
  mov al, n
  out dx, al
  inc dx
  mov al, r
  out dx, al
  mov al, v
  out dx, al
  mov al, b
  out dx, al
end;

{Attend la fin du balayage vertical}
procedure vsync;
begin
  repeat until port[$3da] and 8=0;
  repeat until port[$3da] and 8<>0;
end;

{Attend la fin du balayage horizontal}
procedure hsync;
begin
  repeat until port[$3da] and 1=0;
  repeat until port[$3da] and 1<>0;
end;

{Retourne le nombre de tick,  18.206ticks par seconde}
function timer:longint;assembler;
asm
  xor ah, ah
  int 1ah
  mov ax, dx
  mov dx, cx
end;

{Retourne false si on est excut depuis une fentre sous Win}
function testfull:boolean;
var time:longint;
    i:integer;
begin
  {On est sur qu'on est en mode text co80}
  asm
    mov ax, 3h
    int 10h
  end;
  time:=timer;
  {On attend la fin de 18 balayages, cad  peu prs un quart de seconde}
  for i:=1 to 18 do vsync;
  {Il faut que a ait pris un certain temps, avec une marge d'erreur}
  testfull:=(timer-time)/18.206>0.2;
end;


begin
  {Petits malins, va...}
  if not testfull then begin
    writeln('Ce programme ne fonctionne pas en mode fenestr sous Windows.');
    writeln('Veuillez le relancer en mode plein cran ou sous Dos.');
    exit;
  end;

  {Multitche? Irq? Connais pas a moi...}
  asm
    cli
  end;

  writeln;
  writeln('Bijour les petits enfants!');
  writeln('Il y a bien longtemps (sans doute dans une lointaine galaxie)');
  writeln('vivait notre pote l''Atari...');
  writeln;
  writeln('Bah sur l''Atari yavait moyen de faire ce que vous voyez');
  writeln('actuellement  l''cran : changer de palette de couleur ');
  writeln('chaque ligne.');
  writeln;
  writeln('Aucun truc ici : nous somme bien en mode texte 80x25 BIOS 03h');
  writeln('classique du dos : le mode co80.');
  writeln;
  writeln('Cet effet est appel le raster. J''avoue que dans le cas');
  writeln('qui nous occupe, il me serait difficile de faire bouger');
  writeln('beaucoup de choses sur cet cran pendant la gestion de cet');
  writeln('effet : j''ai besoin de tout le cpu...');
  writeln;
  writeln('Nanmoins, en perfectionnant un chtit peu, et en vitant de');
  writeln('faire cet effet sur toutes les lignes (ce qui est le cas');
  writeln('actuellement), on peut faire une belle dmo.');
  writeln;
  writeln('Cet effet fonctionne en mode texte, mais s''applique galement');
  writeln('en mode graphique (n''importe lequel en fait), quelle que soit');
  writeln('sa rsolution ou son mode de couleur (mme monochrome!).');

  {Et une palette de couleur en mmoire, une...}
  for y:=0 to 63 do begin
    pal[y+000,0]:=   y;pal[y+000,1]:=   y;pal[y+000,2]:=   0;
    pal[y+064,0]:=63-y;pal[y+064,1]:=63-y;pal[y+064,2]:=   0;
    pal[y+128,0]:=   0;pal[y+128,1]:=   y;pal[y+128,2]:=   y;
    pal[y+192,0]:=   0;pal[y+192,1]:=63-y;pal[y+192,2]:=63-y;
    pal[y+256,0]:=   y;pal[y+256,1]:=   0;pal[y+256,2]:=   y;
    pal[y+320,0]:=63-y;pal[y+320,1]:=   0;pal[y+320,2]:=63-y;
  end;

  {La couleur de la premire ligne}
  c0:=0;
  repeat
    c:=c0;
    inc(c0);
    if c0=384 then c0:=0;
    {Attendons la fin du balayage}
    vsync;
    {Mettons cette zone en noire : ce qui prcde la zone affichable}
    setcolor(0,0,0,0);
    for y:=1 to 399 do begin
      {Attendons la fin du balayage horizontal}
      hsync;
      {On modifie en vitesse les couleurs, ni vu ni connu}
      setcolor(0,pal[c,0],pal[c,1],pal[c,2]);
      setcolor(7,63-pal[c,0],63-pal[c,1],63-pal[c,2]);
      inc(c);
      if c=384 then c:=0;
    end;
    {Pour le peu qu'il reste  parcourir, on va faire a en noir}
    setcolor(0,0,0,0);
  until port[$60]=1;

  {On restaure la palette et on ractive les IRQ}
  asm
    mov ax, 03h
    int 10h
    sti
  end;

  writeln('Parfois ce programme bloque la touche CTRL : si votre clavier');
  writeln('semble rpondre d''une faon bizare, appuyez une fois sur');
  writeln('la touche CTRL...');
  writeln;
  writeln('Par Plouf : plouf@win.be');
end.